# -*- coding: iso-8859-15 -*-

#
# Basisklasse fuer Authentifizierung
# 
# Die Autentifizierung basiert auf einer 
# Sessionvariable namens user. Ist diese
# gesetzt gilt der Benutzer als angemeldet
# 
# 
# 
# 
class AuthenBase(object):
   user = None
   session = None
   rights = None
   userlist = {}


   def __init__(self,session=None):
      if session == None:
         raise(Exception('Das Objekt muss mit einem Sessionobjekt befuellt werden'))
      self.session = session
      self.init()

   def getUser(self):
      return self.user

   def init(self):
      self.user      = self.session.getAttribute('user')
      theUser = self.getUserinfo(user=self.user)
      self.rights    = theUser.get('rights')


   def isAuthenticated(self):
      'Liefert wahr, wenn benutzer vorhanden ist'
      if self.user != None:
         return True
      else:
         return False

   def getRights(self):
      'ABSTRAKT: liefert eine Liste von Rechten, wenn Benutzer eingelogt'
      if self.isAuthenticated():
         return self.rights
      else:
         return []

   def hasRight(self,right=None):
      'Liefert True, wenn uebergebenens Recht in der Rechteliste vorhanden ist'
      if self.isAuthenticated():
         found = False
         for theRight in self.rights:
            if right == theRight: found = True
         return found
      else:
         return False

   def getUserinfo(self,user=''):
      found = None
      for usr in self.userlist:
         if usr['user'] == user:
            found = usr
      
      if found == None:
         return {}
      else:
         return found


   def getPassword(self):
      user = self.getUserinfo()
      if user != {}:
         return None
      else:
         return user['password']
      
   def authen(self):
      if self.user != None:
         user = getUserinfo()
         self.rights = user['rights']
