# -*- coding: iso-8859-15 -*-
import cgi
import os

from conf.menu import Menu
from conf.config import Config
from conf.authen import Authen
from conf.sidebox import Sidebox
from templateengine import TemplateEngine
from viewhandler import Viewhandler
from dbaccess import *
from session import Session
from version import Version


# ### Hauptklasse des Frameworks
#
class Mframe:
   form=None                           # aktuelle Form (gesetzt aus CGI)
   webini=None                         # 
   menu=None                           # Menu Objekt
   homeurl='start.py'                  # HOME URL
   path=None                           # Aktueller Pfad gesetzt aus der CGI Variabel path
   db=None                             # Databasehandle
   session=None                        # Session Objekt
   authen=None                         # Autentifizierungsmodul
   container='default.tpl'
   tplateengine = TemplateEngine()
   flash=''                            # Meldungszeile
   useAuthen = True                    # Flag zur Benutzung der Autentifizierung
   sidebox = None                      # Sideboxbearbeitung
   config = None                       # Konfigurationsobjekt
   showSideboxes = False               # True wenn Sideboxes angezeigt werden sollen
   sideboxes = ''                      # Container haelt Sideboxes HTML Snippet
   version = None                      # Versionsinformationen
   mframeversion = None                # Versionsnummer von mFrame
   
   defaultMimeHeader = "Content-Type: text/html"
   # ### CGI Parameter
   # Liefert den Ihalt eines CGI Parameters
   #
   def cgiparam(self,name=None,nvl=''):
      'Liefert aus dem CGI einen benannten Parameter'
      
      # wenn Parameter nicht definiert 
      # null-value zurueckgeben
      if name not in self.form:
         return nvl

      try:
         value = self.form[name].value
      except:
          return nvl

      return value
   
   def __init__(self,webini='../../WEB-INF',sessionlifetime=180):
      
      print self.defaultMimeHeader
      # Form inhalte holen
      self.form=cgi.FieldStorage()
      
      # lese path aus CGI
      self.path = self.cgiparam(name='path',nvl='/')
      self.config = Config()
      # Konfiguration
      self.homeurl=self.config.homeurl
      self.webini=webini
      self.menu=Menu()
      self.menu.path = self.path
      self.menu.homeurl=self.homeurl
      self.configMenu()
      self.sidebox = Sidebox()
      self.session = Session(sessionlifetime=sessionlifetime)
      self.authen = Authen(session=self.session)
      self.menu.authen = self.authen
      self.mframeversion = Version().VERSION
      self.version = '1.0'
      # Verbinden mit Datenbank
      # Wenn dbfilename angegeben
      if Config.sqlitefilename != None:
         self.db = Database('sqlite',Config.sqlitefilename)
      
      # heder abschliessen
      # Standard Mime-Header ausgeben
      print self.defaultMimeHeader
      self.session.setCookie()
      print      

   def setContainer(self,name=None):
      'setzt den Container'
      self.tplateengine.tplFileName = name

   def setAttribute(self,name=None,value=None):
      'Weiterleiten an deligiertes Objekt'
      self.session.setAttribute(name,value)

   def getAttribute(self,name=None):
      'Weiterleiten an deligiertes Objekt'
      return self.session.getAttribute(name)

   
   # depricated
   def start_html(self):
      print "<html><body>"
      
   # depricated
   def end_html(self):
      print "</body></html>"
   
   
   def addEntry(self,
               path='/',
               controller=None,
               text=None):
               
      'Fuegt in die Menueeintraege einen Eintrag dynami="sch hinzu'
      aux = {}
      aux['text']=text
      aux['path']=path
      if controller != None:
        aux['controller']=controller

      self.menu.entries.append(aux)


   #Konfigurieren des Menues:
   # @param container      Ein Container in dem die Menueeintraege
   #                       eingefuegt werden 
   #                       Beispiel: '<ul>{0}</ul>'
   # @param entry          Ein Format fuer einen Menueeintrag
   #                       'Beispiel: <a href={0}?path={1}>{2}</a><br />'
   #                       Parameter:
   #                          0   URL
   #                          1   aktueller Pfad
   #                          2   Anzeigetext
   #
   def configMenu(self,container='<ul class="menu">\n%(entry)s</ul>\n',entry=None):
      'Konfigruation des Menu'
      self.menu.tplMenuContainer   = container
      if entry != None:
         self.menu.tplMenuEntry       = entry
      

   # Initialisierung
   def init(self):
      # Wird authentifizierung gewuenscht
      if self.useAuthen:
         # Ist noch niemand angemeldet
         if not self.authen.isAuthenticated():
            self.setContainer(name='login.tpl')
            self.tplateengine.readTemplateFile()
      
   # Starten Framework
   # Diese Routinie gibt die gerenderte HMTL Seite zurueck
   def run(self):

      menu=self.menu.navigation()
      backlink=self.menu.backlink()
      controllerfilename=self.menu.getControllerName()
      controller = self.menu.getController()
      content = ''

      stylesheet=self.config.stylesheet

      self.main = self

      user = self.getAttribute('user')
      if user == None:
         user = ''

      
      if controller != None:
         # Controller initialisieren
         #
         controller.db = self.db
         controller.addEntry = self.addEntry
         controller.main=self
         controller.cgiparam = self.cgiparam
         content = controller.get()
         if content == False:
            return ''

         menu=self.menu.navigation()
         backlink=self.menu.backlink()

         if self.showSideboxes:
            self.sideboxes=self.sidebox.get()

         if self.flash == '':
            if self.cgiparam(name='flash',nvl='') != '':
               self.flash = self.cgiparam(name='flash',nvl='')
   
      return self.tplateengine.get({
         'stylesheet':stylesheet,
         'body': content,
         'menu':menu,
         'flash':Config.templateFlash % {'flash':self.flash},
         'backlink':backlink,
         'sid':self.session.getSID(),
         'user':user,
         'sideboxes':self.sideboxes,
         'version':self.version,
         'mframeversion':self.mframeversion
         })
