# -*- coding: iso-8859-15 -*-
"""Basisklasse fuer Elementen zur Bildschirmdarstellung im Browser"""


class Taglib():


   input_text_container='<input type="text" name="%(name)s" value="%(value)s" %(more)s />'
   input_hidden_container='<input type="hidden" name="%(name)s" value="%(value)s" />'
   input_displayandhidden_container='<input type="hidden" name="%(name)s" value="%(value)s" /><div class="displayandhidden">%(value)s</div>'
   input_select_container='<select name="%(name)s" %(more)s >\n %(options)s</select>\n'

   cntTabLn=0

   def __init__(self):
      pass
      

   def getClass(self,theClass):
      """Liefert ein HTML class Attribute wenn nicht None"""
      if theClass != None:
         return ' class="%(class)s" ' % {'class':theClass}
      else:
         return ''

   def getStyle(self,theStyle):
      """Liefert ein HTML style Attribute wenn nicht None"""
      if theStyle != None:
         return ' style="%(style)s" ' % {'style':theStyle}
      else:
         return ''

   def isnull(value,nvl):
      """Wandelt den None in uebergebenen Wert aus nvl um"""
      if value == None:
         return nvl
      else:
         return value

   def promptinput(
      self,
      prompt='',                 # Promptstring
      name=None,                 # Name fuer den HTML Tag
      value='',                  # Wert (value) des Tags, bei Type=Select der vorselektierte Wert
      maxlength=None,            # Maxlength Attribut des Inputtags
      size=None,                 # Size Attribut des Inputtags
      css_class=None,            # CSS Klassenname
      datasource=None,           # Datasource fuer Select Tag
      tr=True,                   # Das Widget wird in HTML Tabellenzeile eingefuegt
      style=None,                # Style Attribut des Tags
      type='text',               # Type text, select, displayandhidden, submit
      nvl=None                   # Vorgabewert wenn value None ist
      ):
      """Liefert ein Input Widget"""

      more = []
      if maxlength   != None:  more.append('maxlength="%(val)s"' % {'val':maxlength})
      if size        != None:  more.append('size="%(val)s"' % {'val':size})

      myClass = self.getClass(css_class)
      if myClass != '':
         more.append(myClass)

      myStyle = self.getStyle(style)
      if style != None:
         myStyle = ' style="%(style)s" ' % {'style':style}

      # Wenn value None ist wird der 
      # angegebene Wert als Vorgabe eingesetzt
      if nvl != None and value == None:
         value = nvl
      
      if type == 'text':            
         widget = self.input_text_container % {
            'name':name, 
            'value':value, 
            'more':' '.join(more)
            }
      
      if type == 'displayandhidden':
         widget = self.input_displayandhidden_container % {
            'name':name, 
            'value':value
            }

      
      if type == 'select' :
         if datasource == None:
            raise Exception('Methode promptinput mit Type select benoetigt den Parameter datasource')
         aOptions = []

         
         for option in datasource:
            selected = ''
            if (len(option) < 3):
               if str(option[0]) == str(value): selected = ' selected '

            aOptions.append(' <option value="%(val)s"%(selected)s>%(text)s</option>\n' % {
               'val':option[0],
               'text':option[1],
               'selected':selected
               })
          
         widget = self.input_select_container % {
            'name':name, 
            'value':value, 
            'more':' '.join(more),
            'options':' '.join(aOptions)
            }

      if type=='submit':
         nameatt = ''
         if name != None:
            nameatt = ' name="%(name)s" ' %{'name':name}
         widget='<input type="submit" value="%(value)s" %(nameatt)s/>' % {'value':value,'nameatt':nameatt}

      # Wird einbettung in HTML Tabelle gewuenscht
      if tr:
         retval = '<tr><td>%(prompt)s</td><td>%(widget)s</td></tr>' % {
            'prompt':prompt,
            'widget':widget
            }
      else: retval = '%(prompt)s%(widget)s' % {'prompt':prompt,'widget':widget}

      return retval



   def form(self,name=None,style='display:inline;',css_class=None,method='get'):
      """Liefert einen Form-Tag
         @name        Name der Form. Default: 'edit'
         @style       Styleattribut. Default: 'display:inline'
         @css_class   Classattribute. Default: Kein class
         """

      if name==None: name='edit'
      myStyle = self.getStyle(style)

      return '<form name="%(name)s" %(style)s method=%(method)s>' % {'name':name,'style':myStyle,'method':method}


   def endform(self):
      """Liefert einen End-Form Tag"""
      return '</form>'


   def table(self,name=None,style=None,colgroup=None):
      """Liefert eine Table-Tag
         @param name          Name der Table
         @param style         Style Atritbute. Default nichts
         @param colgroup      Liefert nach dem Table-Tag ein Colgroup Tag
                              mit der Anzahl der Cols mit Breite 1%, Abschliessend
                              wird ein weitere Col Attribute mit dem Wert 99% eingefuegt
         """
      
      # Tabellen Zeilenzaehler auf Null stellen
      self.cntTabLn=0

      myName = ''
      if name != None:
        myName = ' name="%(name)s" ' % {'name':name }
      myStyle = self.getStyle(style)
      aColgroup = []

      if colgroup != None:
         aColgroup.append('\n<colgroup>')
         for cg in range(1,int(colgroup)):
            aColgroup.append('<col width="1%">')
         aColgroup.append('<col width="99%">\n</colgroup>')
         colgroup = '\n '.join(aColgroup)
      else:
        colgroup = ''

      retval = '<table %(name)s%(style)s>%(colgroup)s' %{'name':myName,'style':myStyle,'colgroup':colgroup }
      return retval


   def tablehead(self,heads,css_class=None,style=None):
      """ Liefert eine Tabellenzeile
          @param heads        ist eine Liste von Tabellenkoepfe
          @param css_class    CSS Klasse fuer TH Element
          @param style       Style Attribut fuer TH Element
          """
      if heads == None:
         raise Exception("tablehead muss den parameter heads haben")
      
      ths = []
      ths.append('<tr>')
      myClass = self.getClass(css_class)
      myStyle = self.getStyle(style)
      for head in heads:
         ths.append('<th%(class)s%(style)s>%(text)s</th>' % {'class':myClass,'text':head,'style':myStyle})
      ths.append('<th>')
      return ''.join(ths)
         
   def tablerow(self,values,usezebra=True):
      """Liefert eine Tabellenzeile"""

      thClass=''

      if usezebra:         
         self.cntTabLn+=1
         if self.cntTabLn % 2 != 0:
            thClass=' class="line-1" '
         else :
            thClass=' class="line-2" '

      vals=[]

      for value in values:
         vals.append('<td>%(value)s</td>' % {'value':value})
      
      retval = '<tr%(class)s>'+'\n'.join(vals)+'</tr>'
      return  retval % {'class':thClass}

   def endtable(self):
      """Liefert ein End-Table HTML Tag"""
      return '</table>'

   def hidden(self,name=None, value=None):
      """Liefert eine Hidden Inputtag"""
      if name==None:  raise Exception('hidden muss den Parameter name haben')
      if value==None:  raise Exception('hidden muss den Parameter value haben')
      return '<input type="hidden" name="%(name)s" value="%(value)s" />' % {'name':name,'value':value}

   def gridButtons(self,id=None,addhidden=[],deletebutton=True,editbutton=True):
      retval = []
      retval.append('<nobr>')
      if editbutton:
         retval.append(self.form(name='griededit',style='display:inline;'))
         retval.append(self.hidden(name='action',value='edit'))
         retval.append(self.hidden(name='id',value=id))
         for hidden in addhidden:
            retval.append(self.hidden(name=hidden[0],value=hidden[1]))
         retval.append('<input type="image" src="../images/skin/normal/database_edit.png" border="0" alt="speichern" />')
         retval.append(self.endform())

      if deletebutton:
         retval.append(self.form(name='griededit',style='display:inline;'))
         retval.append(self.hidden(name='action',value='delete'))
         retval.append(self.hidden(name='id',value=id))
         for hidden in addhidden:
            retval.append(self.hidden(name=hidden[0],value=hidden[1]))
         retval.append('<input type="image" src="../images/skin/normal/database_delete.png" border="0" alt="l&ouml;schen" />')
         retval.append(self.endform())
      retval.append('</nobr>')
      
      return '\n'.join(retval)

   def editButton(self,id=None,addhidden=[]):
      retval = []
      retval.append(self.form())
      retval.append(self.hidden(name='action',value='edit'))
      retval.append(self.hidden(name='id',value=id))
      for hidden in addhidden:
         retval.append(self.hidden(name=hidden[0],value=hidden[1]))
      retval.append('<input type="image" src="../images/skin/normal/database_edit.png" border="0" alt="speichern" />')
      retval.append(self.endform())
      return '\n'.join(retval)

  